untyped
global function TLVinit
global function addLoadoutIcons

void function TLVinit()
{
	AddCallback_OnScoreboardPlayerUpdate(addLoadoutIcons)
}


void function addLoadoutIcons(entity player, int index, int team, SuperiorFile file)
{
	//Logger.Info("Func ran!")
	//RuiSetImage( rui, "extraIcon" + "0", $"r2_ui/menus/loadout_icons/primary_weapon/primary_softball" )
	var elemTable = file.playerElems[team][index]

	var rui = Hud_GetRui( elemTable.background )
	
	for(int i = 0; i < 6; i++) //clearing extra icons
	{
		RuiSetImage( rui, "extraIcon" + i, $"" )
	}
	
	if(IsAlive(player))
	{
		//Logger.Info("alive")
		entity soul = GetSoulFromPlayer(player)
		entity titan = null
		asset titanIcon
		int currentExtraIconIndex = 0
	
		if(player.IsTitan() && GetConVarInt("enable_titans_display") != 0)
		{
			titan = soul.GetTitan()
			//Logger.Info(GetTitanCharacterName(titan))
			titanIcon = GetIconForTitanClass(GetTitanCharacterName(titan))
			RuiSetImage( rui, "extraIcon" + currentExtraIconIndex++, titanIcon )
		}
		else
		{
			//Print order (reversed in game): Ordnance, tactical, weapon3, secondary, primary, titan
			asset weaponIcon
			asset tacticalIcon
			asset ordnanceIcon
			array <entity> weapons = player.GetMainWeapons()
			array <entity> offhand = player.GetOffhandWeapons()
			
			if(GetConVarInt("enable_ordnances_display") != 0 && offhand.len() > 0 && offhand[0] != null)
			{
				ordnanceIcon = GetWeaponInfoFileKeyFieldAsset_Global( offhand[0].GetWeaponClassName(), "hud_icon" )
				RuiSetImage( rui, "extraIcon" + currentExtraIconIndex++, ordnanceIcon )
			}
			if(GetConVarInt("enable_tacticals_display") != 0 && offhand.len() > 1 && offhand[1] != null)
			{
				tacticalIcon = GetWeaponInfoFileKeyFieldAsset_Global( offhand[1].GetWeaponClassName(), "hud_icon" )
				RuiSetImage( rui, "extraIcon" + currentExtraIconIndex++, tacticalIcon )
			}
			if(weapons.len() > 0)
			{
				for(int i = weapons.len(); i > 0; i--)
				{
					if(i == 1 && GetConVarInt("enable_primaries_display") != 0 || i > 1 && GetConVarInt("enable_secondaries_display") != 0)
					{
						weaponIcon = GetWeaponInfoFileKeyFieldAsset_Global( weapons[i-1].GetWeaponClassName(), "hud_icon" )
						RuiSetImage( rui, "extraIcon" + currentExtraIconIndex++, weaponIcon )
					}
				}
			}
			if(GetConVarInt("enable_titans_display") != 0 && player.GetPetTitan() != null)
			{
				titan = soul.GetTitan()
				//Logger.Info(GetTitanCharacterName(titan))
				titanIcon = GetIconForTitanClass(GetTitanCharacterName(titan))
				RuiSetImage( rui, "extraIcon" + currentExtraIconIndex++, titanIcon )
			}
		}
	}
}